package indi.felix.easy.core.elastic.utool;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.elasticsearch.action.index.IndexRequest;

import java.util.Map;

public class EsUtils {

    public static IndexRequest setDefaultProperties(IndexRequest indexRequest, Object object) {
        JSONObject jsonObject = null;
        if (object instanceof JSONObject) {
            jsonObject = (JSONObject) object;
        } else if(object instanceof String){
            jsonObject = JSON.parseObject(object.toString());
        } else {
            jsonObject = (JSONObject) JSONObject.toJSON(object);
        }

        if (jsonObject.containsKey(Const.ID)) {
            String id = jsonObject.getString(Const.ID);
            if (StringUtils.isNotBlank(id)) {
                indexRequest.id(id);
            }
        }

        if (jsonObject.containsKey(Const.ROUTING)) {
            String routing = jsonObject.getString(Const.ROUTING);
            if (StringUtils.isNotBlank(routing)) {
                indexRequest.routing(routing);
            }
        }

        if (jsonObject.containsKey(Const.PARENT)) {
            String parent = jsonObject.getString(Const.PARENT);
            if (StringUtils.isNotBlank(parent)) {
                indexRequest.parent(parent);
            }
        }

        return indexRequest;
    }
}
