package indi.felix.easy.canal.disruptor.service.impl;

import indi.felix.easy.canal.disruptor.TableData;
import indi.felix.easy.canal.disruptor.service.DisruptorService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Service;

/**
 * 异步队列服务
 *
 * @author felix
 * @since JDK 1.8
 */
@Service
@Slf4j
public class DisruptorServiceImpl implements DisruptorService, ApplicationListener<ContextRefreshedEvent> {

    /**
     * 异步处理服务<br/>
     * <br/>
     *
     * @param tableData :
     * @return void
     **/
    @Override
    public void execute(TableData tableData) {
        if (log.isDebugEnabled()) {
            log.debug("接受数据更新请求，更新表名:{},更新的主键为:{}", tableData.getTableName(), tableData.getId());
        }

        if (null != tableData) {
            //业务处理 TODO
            System.out.println("业务处理: aaaaa");
        }
    }

    /**
     * 初始化所有的service服务
     */
    private void initAllCacheService() {
        log.info(">>> 初始化所有需要缓存的服务对象.....");
        //业务需要初始化一些处理
        System.out.println("aaaaa");
    }

    @Override
    public void onApplicationEvent(ContextRefreshedEvent contextRefreshedEvent) {
        initAllCacheService();
    }
}
